const Cc = Components.classes;
const Ci = Components.interfaces;
const Cr = Components.results;
Components.utils.import('resource://gre/modules/XPCOMUtils.jsm');
Components.utils.import('resource://gre/modules/Services.jsm');
Components.utils.import('resource://gre/modules/AddonManager.jsm');
Components.utils.import("resource://gre/modules/NetUtil.jsm");

function kmAddon() {
}

kmAddon.prototype = {
classID: Components.ID('{6e4995c3-deef-46a2-be73-154647710190}'),
observe: function(aSubject, aTopic, aData) {
  switch (aTopic) {
    case 'app-startup' :	
      Services.obs.addObserver(this, 'content-document-global-created', false);
      break;
    case 'content-document-global-created'	:	
      var o={},KMeleon = Components.classes["@kmeleon/jsbridge;1"].getService(Components.interfaces["nsIJSBridge"]);
      AddonManager.getAddonsByTypes(["extension"], function(addons) {
        Services.console.logStringMessage('kmAddon: Got addons\n');
        addons.forEach(function(a) {
          if (a.isActive)
          {
            var uri = a.getResourceURI('load.kmm');
            try {
              NetUtil.asyncFetch(uri, function(aInputStream, aResult) {
                // Check that we had success.
                if (!Components.isSuccessCode(aResult)) {
                  return;
                }
                var macro = NetUtil.readInputStreamToString(aInputStream, aInputStream.available());
                KMeleon.SendMessage("macros", "kmAddon", "RunMacro", macro, {});
                // Consume the input stream.
              });
            } catch (e) {
              Services.console.logStringMessage('kmAddon: not loading ' + uri.spec+ '\n');
            }            
          }
        });
      });
      Services.obs.removeObserver(this, 'content-document-global-created');
      break;			
    case 'xpcom-shutdown' :	
    	break;
  }
},
QueryInterface: XPCOMUtils.generateQI([Ci.nsIObserver, Ci.nsISupportsWeakReference]),
_xpcom_categories: [{category: 'app-startup'}]
};
const NSGetFactory = XPCOMUtils.generateNSGetFactory([kmAddon]);